<?php
/*-----------------------------------------------------
    NewsLister feed.php
	
	@version    1.0.2
	@copyright Tenderfeel
	@author Tenderfeel(tenderfeel@gmail.com)
	@link http://tenderfeel.xsrv.jp/
	
	[2010/03/15] 1.0.2
	 + Atom1.0 ǉ
	 
	1.0.0 -> 1.0.1 sxNGXg@ɖ߂
------------------------------------------------------*/	

	require_once("include/config.php");
	require_once("include/post.php");
	require_once("include/FastJSON.class.php");
	
//RSS
if(isset($_GET["viewtype"])&&$_GET["viewtype"]=="rss"){
		
	header('Content-Type: application/rss+xml; charset=UTF-8');
	$logdata = load_data();
	
	echo '<?xml version="1.0" encoding="UTF-8"?'.'>'."\n";?>

<rss version="2.0"
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:wfw="http://wellformedweb.org/CommentAPI/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:atom="http://www.w3.org/2005/Atom"
	xmlns:sy="http://purl.org/rss/1.0/modules/syndication/">
	<channel>
	<title><?php echo(RSS_TITLE); ?></title>
	<atom:link href="<?php echo self_link(); ?>" rel="self" type="application/rss+xml" />
	<link><?php echo(SITEURL);//site url ?></link>
	<description><?php echo(RSS_DESCRIPT);//description ?></description>
	<language>ja</language>
	<pubDate><?php echo(get_lastpostmodified());//pubDate ?></pubDate>
	<lastBuildDate><?php echo(get_lastpostmodified());//pubDate ?></lastBuildDate>
	<docs>http://blogs.law.harvard.edu/tech/rss</docs>
	<generator><?php echo(SCRIPT." ".VERSION) ?></generator>
	<webMaster><?php print RSS_AUTHOR ?></webMaster>
	<?php foreach($logdata as $i => $data ){ ?>
<item>
		<title><?php print date("Y-m-d H:i",$data["date"]); ?></title>
		<link><?php echo(SITEURL);//site url ?></link>
		<description><![CDATA[<?php print($data["comment"]); ?>]]></description>
		<pubDate><?php print(gmdate('D, d M Y H:i:s',$data["date"])." GMT"); ?></pubDate>
		<guid isPermaLink="false"><?php print(RSS_TITLE."-post-".$data["id"]); ?></guid>
	</item>
	<?php } ?>
	</channel>
</rss>

<?PHP
}
//ATOM
if(isset($_GET["viewtype"])&&$_GET["viewtype"]=="atom"){
		
	header('Content-Type: application/atom+xml; charset=UTF-8');
	$logdata = load_data();
	
	echo '<?xml version="1.0" encoding="UTF-8"?'.'>'."\n";?>

<feed xmlns="http://www.w3.org/2005/Atom"
  xmlns:thr="http://purl.org/syndication/thread/1.0"
  xml:lang="ja"
  xml:base="<?php echo self_link(); ?>">
  
	<title><?php echo(RSS_TITLE); ?></title>
	<subtitle type="text"><?php echo(RSS_DESCRIPT);//description ?></subtitle>
	<updated><?php echo(get_lastpostmodified("atom"));//pubDate ?></updated>
	<link rel="self" type="application/atom+xml" href="<?php echo self_link(); ?>" />
	<link rel="alternate" type="text/html" href="<?php echo(SITEURL);//site url ?>" />
	<generator><?php echo(SCRIPT." ".VERSION) ?></generator>
	<id><?php echo self_link(); ?></id>
	<?php foreach($logdata as $i => $data ){ ?>
<entry>
		<title type="text"><?php print date("Y-m-d H:i",$data["date"]); ?></title>
		<link rel="alternate" type="text/html" href="<?php echo(SITEURL); ?>" />
		<id>tag:<?php print(str_replace("www.","", $HTTP_SERVER_VARS["SERVER_NAME"])); ?>,<?php print date("Y",$data["date"]); ?>:<?php print(RSS_TITLE."-post-".$data["id"]); ?></id>
		<updated><?php print(date3339($data["date"])); ?></updated>
		<author><name><?php print RSS_AUTHOR ?></name></author>
		<summary type="html"><![CDATA[<?php print(trim($data["comment"])); ?>]]></summary>
</entry>
	<?php } ?>
</feed>

<?PHP
}

//JSONP
	if((isset($_POST["viewtype"], $_POST["max"]) && $_POST["viewtype"]=="json")){
		header('Content-Type: application/x-javascript; charset=UTF-8');
		$callback = isset($_POST["callback"]) ? $_POST["callback"]:"jsoncallback";
		$p = isset($_POST["page"])? $_POST["page"]:0;
		$logdata = get_data($p, $_POST["max"]);
		
		print $callback . "({\"items\":".FastJSON::convert($logdata[0]).",\"pagenum\":".ceil($logdata[1]).",\"current\":".$_GET["page"].", \"count\":".$logdata[2]."});";
	
	}
	
	if(isset($_GET["viewtype"], $_GET["max"]) && $_GET["viewtype"]=="json"){
		
		header('Content-Type: application/x-javascript; charset=UTF-8');
		$callback = isset($_GET["callback"]) ? $_GET["callback"]:"jsoncallback";
		$p = isset($_GET["page"])? $_GET["page"]:0;
		$logdata = get_data($p, $_GET["max"]);
		
		print $callback . "({\"items\":".FastJSON::convert($logdata[0]).",\"pagenum\":".ceil($logdata[1]).",\"current\":".$_GET["page"].", \"count\":".$logdata[2]."});";
	}

?>